#include "hobot_can_hal.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_RX_BUF_SIZE 4000

static void help_info(const char *proc) {
  printf("Usage: %s target\n"
	"example target: bypass\n",
	proc);
}

int main(int argc, char *argv[])
{
	int ret = 0;
	char target[16] = {0};
	struct pack_info pack;
	pack.length = MAX_RX_BUF_SIZE / sizeof(struct canframe);
	if (argc < 2) {
		help_info(argv[0]);
		return 0;
	}
	strcpy(target, argv[1]);
	ret = canInit();
	if (ret < 0)
	{
		printf("INIT ERROR!\n");
		return ret;
	}
	while(1)
	{
		struct canframe *frame = malloc(MAX_RX_BUF_SIZE);
		if (frame == NULL)
		{
			printf("malloc memory fail!\n");
			return -1;
		}
		memset(frame, 0, MAX_RX_BUF_SIZE);
		canRecvMsgFrame(target, frame, &pack);
		printf("*********************************************\n");
		printf("[%s] [pack]length: %d soc_ts: %ld mcu_ts: %ld\n", target, pack.data_num, pack.soc_ts, pack.mcu_ts);
		struct canframe *frame_1 = frame;
		for (int i = 0; i < pack.data_num; i++)
		{
			if (frame_1->len == 0)
				continue;
			if (NULL != frame_1) {
				/*Echo received data info*/
				printf("[canhal_get] [%s] [canframe] canid is 0x%08x timestamp is 0x%lx data is:\n",\
					target, frame_1->canid,frame_1->time_stamp);
				for(int j = 0; j < frame_1->len; j++){
					printf(" 0x%x ",frame_1->data[j]);
				}

				printf("\n");

				frame_1++;
			}
		}
		free(frame);
	}
	canDeInit();
	return 0;
}
